
* This program code is released under a Berkeley Systems Distribution 
  BSD-2-Clause license, an open-source license which permits free 
  reuse and republication under conditions;

/*
Copyright (c) 2014, Thomas E. Billings and Avinash Kalwani 
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/


* code to test USER= option.  Change pathname to a falid location on your system;

libname test "pathname";
options user=test;

data company;
   input id $ dept $;
   datalines;
X Sales
Y Acct
Z HR
;

* test program #1 - mylib=WORK;

%let mylib=WORK;   *  test #1:  WORK library;
options mprint nocenter;
options nosyntaxcheck replace;    * make sure OPTIONS are set as desired;
data &mylib..temp;    * create test data set;
	x=1;
	output;
	stop;
run;

options noreplace;
data &mylib..mistake;   * force an error;
	y = 1;
	z = fakefunction(y);
	stop;
run;

data &mylib..temp;   * check if replaced;
	set &mylib..temp;
	y = 1;
run;

proc print data=&mylib..temp;
	title "test #1 - using WORK libname";
run;

* test program #2: mylib=meta-LIBNAME.  Change to valid LIBNAME on your system;

%let mylib=CDMCNTL;     *  test #2:  permanent library;
%*libname &mylib. "path/address_here";    * not needed as this
                                            is a meta-libname;
options nosyntaxcheck replace;    * make sure OPTIONS are set as desired;
data &mylib..temp2;
	x=1;
	output;
	stop;
run;

options noreplace;
data &mylib..mistake2;
	y = 1;
	z = fakefunction(y);
	stop;
run;

data &mylib..temp2;
	set &mylib..temp2;
	y = 1;
run;

proc print data=&mylib..temp2;
	title "test #2 - using permanent libname";
run;

